Index: trunk/source/processes/hadronic/models/management/include/G4HadronicInteraction.hh
===================================================================
--- trunk/source/processes/hadronic/models/management/include/G4HadronicInteraction.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/management/include/G4HadronicInteraction.hh	(revision 1055)
@@ -25,23 +25,25 @@
 //
 //
-// $Id: G4HadronicInteraction.hh,v 1.8 2007/01/11 05:30:01 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4HadronicInteraction.hh,v 1.9 2009/01/24 11:56:27 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
- // Hadronic Interaction  abstract base class
- // This class is the base class for the model classes.
- // It sorts out the energy-range for the models and provides
- // class utilities.
- // original by H.P. Wellisch
- // Modified by J.L.Chuma, TRIUMF, 21-Mar-1997
- // Last modified: 3-Apr-1997
- // Added units to energy initialization: J.L. Chuma  04-Apr-97
- // Modified by J.L.Chuma, 05-May-97  to Initialize theBlockedCounter
- // Modified by J.L.Chuma, 08-Jul-97 to implement the Nucleus changes
- // Adding a registry for memory management of hadronic models, HPW 22-Mar-99
+// Hadronic Interaction  abstract base class
+// This class is the base class for the model classes.
+// It sorts out the energy-range for the models and provides
+// class utilities.
+// original by H.P. Wellisch
+// Modified by J.L.Chuma, TRIUMF, 21-Mar-1997
+// Last modified: 3-Apr-1997
+// Added units to energy initialization: J.L. Chuma  04-Apr-97
+// Modified by J.L.Chuma, 05-May-97  to Initialize theBlockedCounter
+// Modified by J.L.Chuma, 08-Jul-97 to implement the Nucleus changes
+// Adding a registry for memory management of hadronic models, HPW 22-Mar-99
+// 23-Jan-2009 V.Ivanchenko move constructor and destructor to the body
+//                          and reorder methods in the header 
 
 // Class Description
 // This is the base class for all hadronic interaction models in geant4.
-// If you want to implement a new way of producing a final state, please inherit
-// from here.
+// If you want to implement a new way of producing a final state, please,
+//  inherit from here.
 // Class Description - End
  
@@ -50,5 +52,4 @@
  
 #include "G4HadFinalState.hh"
-#include "G4DynamicParticle.hh"
 #include "G4ReactionDynamics.hh"
 #include "G4Material.hh"
@@ -56,153 +57,133 @@
 #include "G4Track.hh"
 #include "G4HadProjectile.hh"
-#include "G4HadronicInteractionRegistry.hh"
-#include "G4HadronicException.hh"
 
- class G4HadronicInteraction
- {
- public:
+class G4HadronicInteraction
+{
+public: // With description
+
     
-    G4HadronicInteraction(const G4String& modelName = "HadronicModel") :
-      verboseLevel(0), theMinEnergy(0.0*GeV), theMaxEnergy(25.0*GeV), 
-      isBlocked(false), theModelName(modelName)
-    { 
-      G4HadronicInteractionRegistry::RegisterMe(this);
-    }
+  G4HadronicInteraction(const G4String& modelName = "HadronicModel");
     
-    virtual ~G4HadronicInteraction()
-    {
-      G4HadronicInteractionRegistry::RemoveMe(this);
-    }
+  virtual ~G4HadronicInteraction();
     
- private:
+  virtual G4HadFinalState *ApplyYourself(const G4HadProjectile &aTrack, 
+					 G4Nucleus & targetNucleus ) = 0;
+  // This is the interface to implement for final state production code.
+   
+  virtual G4bool IsApplicable(const G4HadProjectile &/*aTrack*/, 
+			      G4Nucleus & /*targetNucleus*/)
+  {  return true;}
+ 
+  inline G4double GetMinEnergy() const
+  { return theMinEnergy; }
     
-    inline G4HadronicInteraction(
-     const G4HadronicInteraction &right )
-    { *this = right; }
+  virtual G4double GetMinEnergy( const G4Material *aMaterial,
+				 const G4Element *anElement ) const;
+   
+  inline void SetMinEnergy( const G4double anEnergy )
+  { theMinEnergy = anEnergy; }
     
-    inline const G4HadronicInteraction & operator=(
-     const G4HadronicInteraction &right )
-    { 
-     G4String text = "unintended use of G4HadronicInteraction::operator=";
-     throw G4HadronicException(__FILE__, __LINE__, text); 
-     return right;
-    }
+  virtual void SetMinEnergy( G4double anEnergy, G4Element *anElement );
     
- public:
+  virtual void SetMinEnergy( G4double anEnergy, G4Material *aMaterial );
     
-    inline G4bool operator==(
-     const G4HadronicInteraction &right ) const
-    { return ( this == (G4HadronicInteraction *) &right ); }
+  inline G4double GetMaxEnergy() const
+  { return theMaxEnergy; }
     
-    inline G4bool operator!=(
-     const G4HadronicInteraction &right ) const
-    { return ( this != (G4HadronicInteraction *) &right ); }
+  virtual G4double GetMaxEnergy( const G4Material *aMaterial,
+				 const G4Element *anElement ) const;
     
-    inline G4double GetMinEnergy() const
-    { return theMinEnergy; }
+  inline void SetMaxEnergy( const G4double anEnergy )
+  { theMaxEnergy = anEnergy; }
     
-    virtual G4double GetMinEnergy( const G4Material *aMaterial,
-                                  const G4Element *anElement ) const;
+  virtual void SetMaxEnergy( G4double anEnergy, G4Element *anElement );
     
-    inline void SetMinEnergy( const G4double anEnergy )
-    { theMinEnergy = anEnergy; }
-    
-    virtual void SetMinEnergy( G4double anEnergy, G4Element *anElement );
-    
-    virtual void SetMinEnergy( G4double anEnergy, G4Material *aMaterial );
-    
-    inline G4double GetMaxEnergy() const
-    { return theMaxEnergy; }
-    
-    virtual G4double GetMaxEnergy( const G4Material *aMaterial,
-                                  const G4Element *anElement ) const;
-    
-    inline void SetMaxEnergy( const G4double anEnergy )
-    { theMaxEnergy = anEnergy; }
-    
-    virtual void SetMaxEnergy( G4double anEnergy, G4Element *anElement );
-    
-    virtual void SetMaxEnergy( G4double anEnergy, G4Material *aMaterial );
+  virtual void SetMaxEnergy( G4double anEnergy, G4Material *aMaterial );
   
-    inline const G4HadronicInteraction *GetMyPointer() const
-    { return this; }
+  inline const G4HadronicInteraction *GetMyPointer() const
+  { return this; }
 
-    inline G4int GetVerboseLevel() const
-    { return verboseLevel; }
+  inline G4int GetVerboseLevel() const
+  { return verboseLevel; }
 
-    inline void SetVerboseLevel( G4int value )
-    { verboseLevel = value; }
+  inline void SetVerboseLevel( G4int value )
+  { verboseLevel = value; }
 
-    inline const G4String& GetModelName() const
-    { return theModelName; }
-
-public: // With description
-    // This is the interface to implement for final state production code.
-    
-    virtual G4HadFinalState *ApplyYourself(
-            const G4HadProjectile &aTrack, G4Nucleus & targetNucleus ) = 0;
+  inline const G4String& GetModelName() const
+  { return theModelName; }
     
 public: // Without description
 
-    virtual void DeActivateFor( G4Material *aMaterial );
+  virtual void DeActivateFor( G4Material *aMaterial );
     
-    virtual void ActivateFor( G4Material *aMaterial ) 
-    { 
-      Block(); 
-      SetMaxEnergy(GetMaxEnergy(), aMaterial);
-      SetMinEnergy(GetMinEnergy(), aMaterial);
-    }
+  virtual void ActivateFor( G4Material *aMaterial ) 
+  { 
+    Block(); 
+    SetMaxEnergy(GetMaxEnergy(), aMaterial);
+    SetMinEnergy(GetMinEnergy(), aMaterial);
+  }
 
-    virtual void DeActivateFor( G4Element *anElement ); 
-    virtual void ActivateFor( G4Element *anElement )
-    { 
-      Block(); 
-      SetMaxEnergy(GetMaxEnergy(), anElement);
-      SetMinEnergy(GetMinEnergy(), anElement);
-    }
+  virtual void DeActivateFor( G4Element *anElement ); 
+  virtual void ActivateFor( G4Element *anElement )
+  { 
+    Block(); 
+    SetMaxEnergy(GetMaxEnergy(), anElement);
+    SetMinEnergy(GetMinEnergy(), anElement);
+  }
 
-    virtual G4bool IsBlocked( const G4Material *aMaterial ) const;
+  virtual G4bool IsBlocked( const G4Material *aMaterial ) const;
 
-    virtual G4bool IsBlocked( const G4Element *anElement) const;
+  virtual G4bool IsBlocked( const G4Element *anElement) const;
+
+  inline G4bool operator==(const G4HadronicInteraction &right ) const
+  { return ( this == (G4HadronicInteraction *) &right ); }
     
-    virtual G4bool IsApplicable(const G4HadProjectile &/*aTrack*/, 
-                               G4Nucleus & /*targetNucleus*/){  return true;}
- protected:
+  inline G4bool operator!=(const G4HadronicInteraction &right ) const
+  { return ( this != (G4HadronicInteraction *) &right ); }
     
-    G4HadFinalState theParticleChange;
-    // the G4HadFinalState object which is modified and returned
-    // by address by the ApplyYourself method,
-    // (instead of aParticleChange as found in G4VProcess)
+private:
     
-    G4int verboseLevel;
-    // control flag for output messages
-    // 0: silent
-    // 1: warning messages
-    // 2: more
-    // (instead of verboseLevel as found in G4VProcess)
+  G4HadronicInteraction(const G4HadronicInteraction &right );
     
-    G4ReactionDynamics theReactionDynamics;
+  const G4HadronicInteraction& operator=(const G4HadronicInteraction &right);
+
+protected:
+
+  inline G4bool IsBlocked() const { return isBlocked;}
+  inline void Block() { isBlocked = true; }
     
-    // these two have global validity
-    // units are assumed to be MeV
+  G4HadFinalState theParticleChange;
+  // the G4HadFinalState object which is modified and returned
+  // by address by the ApplyYourself method,
+  // (instead of aParticleChange as found in G4VProcess)
     
-    G4double theMinEnergy;
-    G4double theMaxEnergy;
+  G4int verboseLevel;
+  // control flag for output messages
+  // 0: silent
+  // 1: warning messages
+  // 2: more
+  // (instead of verboseLevel as found in G4VProcess)
     
-    G4bool IsBlocked() const { return isBlocked;}
-    void Block() { isBlocked = true; }
-    G4bool isBlocked;
+  G4ReactionDynamics theReactionDynamics;
+    
+  // these two have global validity
+  // units are assumed to be MeV
+    
+  G4double theMinEnergy;
+  G4double theMaxEnergy;
+    
+  G4bool isBlocked;
 
-    G4String theModelName;
+  G4String theModelName;
     
- private:
+private:
         
-    std::vector<std::pair<G4double, G4Material *> > theMinEnergyList;
-    std::vector<std::pair<G4double, G4Material *> > theMaxEnergyList;
-    std::vector<std::pair<G4double, G4Element *> > theMinEnergyListElements;
-    std::vector<std::pair<G4double, G4Element *> > theMaxEnergyListElements;
-    std::vector<G4Material *> theBlockedList;
-    std::vector<G4Element *> theBlockedListElements;
- };
+   std::vector<std::pair<G4double, G4Material *> > theMinEnergyList;
+   std::vector<std::pair<G4double, G4Material *> > theMaxEnergyList;
+   std::vector<std::pair<G4double, G4Element *> > theMinEnergyListElements;
+   std::vector<std::pair<G4double, G4Element *> > theMaxEnergyListElements;
+   std::vector<G4Material *> theBlockedList;
+   std::vector<G4Element *> theBlockedListElements;
+};
  
 #endif
Index: trunk/source/processes/hadronic/models/management/include/G4HadronicInteractionRegistry.hh
===================================================================
--- trunk/source/processes/hadronic/models/management/include/G4HadronicInteractionRegistry.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/management/include/G4HadronicInteractionRegistry.hh	(revision 1055)
@@ -24,4 +24,13 @@
 // ********************************************************************
 //
+// $Id: G4HadronicInteractionRegistry.hh,v 1.4 2009/02/14 19:24:52 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// 23-Jan-2009 V.Ivanchenko make the class to be a singleton
+
+// Class Description
+// This is the a singleton class to store all hadronic interactions
+// Class Description - End
+
 #ifndef G4HadronicInteractionRegistry_h
 #define G4HadronicInteractionRegistry_h 1
@@ -29,32 +38,30 @@
 #include <vector>
 #include "globals.hh"
+
 class G4HadronicInteraction;
 
 class G4HadronicInteractionRegistry
 {
-  public:
+public:
+
+  static G4HadronicInteractionRegistry* Instance();
+  // access 
   
   ~G4HadronicInteractionRegistry();
+
+  void Clean();
+  //delete models
   
-  static void RegisterMe(G4HadronicInteraction * aModel);
-  static void RemoveMe(G4HadronicInteraction * aModel);
+  void RegisterMe(G4HadronicInteraction * aModel);
+  //register new model
+
+  void RemoveMe(G4HadronicInteraction * aModel);
+  //deregister model
     
-  protected:
+private:
 
-  G4HadronicInteractionRegistry(G4String );
-  static G4HadronicInteractionRegistry & theRegistry();
+  G4HadronicInteractionRegistry();
 
-  private:
-
-  //  !!!  can not use "copy constructor" nor "default constructor" !!!!
-       G4HadronicInteractionRegistry(const G4HadronicInteractionRegistry &right) 
-       { nModels = right.nModels; }
-       G4HadronicInteractionRegistry() {nModels = 0;}
-
-  //  !!!  Assignment operation is forbidden !!!
-      const G4HadronicInteractionRegistry & operator=(const G4HadronicInteractionRegistry &) 
-      { return *this;}
-
-  void AddModel(G4HadronicInteraction * aModel);
+  static G4HadronicInteractionRegistry* theInstance;
   
   G4int nModels;
Index: trunk/source/processes/hadronic/models/management/include/G4InelasticInteraction.hh
===================================================================
--- trunk/source/processes/hadronic/models/management/include/G4InelasticInteraction.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/management/include/G4InelasticInteraction.hh	(revision 1055)
@@ -25,20 +25,21 @@
 //
 //
-// $Id: G4InelasticInteraction.hh,v 1.5 2007/01/11 05:30:12 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4InelasticInteraction.hh,v 1.6 2009/01/24 11:56:27 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
- // Hadronic Process: Inelastic Interaction 
- // This class is an abstract base class, since the pure virtual
- // function ApplyYourself has not been defined yet.
- // original by H.P. Wellisch
- // Modified by J.L. Chuma, TRIUMF, 22-Nov-1996
- // Modified by J.L. Chuma  27-Mar-1997
- // Modified by J.L. Chuma  30-Apr-1997
- // Modified by J.L. Chuma  05-Aug-1997  to pass the original incident particle to
- //                                      CalculateMomenta
- // Modified by J.L. Chuma  05-Jun-1998  to include quasiElastic flag to allow for
- //                                      TwoBody to be called directly, bypassing
- //                                      TwoCluster, and allowing TwoCluster to be
- //                                      called with no secondaries
+// Hadronic Process: Inelastic Interaction 
+// This class is an abstract base class, since the pure virtual
+// function ApplyYourself has not been defined yet.
+// original by H.P. Wellisch
+// Modified by J.L. Chuma, TRIUMF, 22-Nov-1996
+// Modified by J.L. Chuma  27-Mar-1997
+// Modified by J.L. Chuma  30-Apr-1997
+// Modified by J.L. Chuma  05-Aug-1997  to pass the original incident particle to
+//                                      CalculateMomenta
+// Modified by J.L. Chuma  05-Jun-1998  to include quasiElastic flag to allow for
+//                                      TwoBody to be called directly, bypassing
+//                                      TwoCluster, and allowing TwoCluster to be
+//                                      called with no secondaries
+// 23-Jan-2009 V.Ivanchenko move constructor and destructor to the body
  
 #ifndef G4InelasticInteraction_h
@@ -53,16 +54,13 @@
 #include "G4ReactionDynamics.hh"
 
- class G4InelasticInteraction : public G4HadronicInteraction
- {
- public:
+class G4InelasticInteraction : public G4HadronicInteraction
+{
+public:
     
-    G4InelasticInteraction(const G4String& modelName = "LEInelastic") 
-     : G4HadronicInteraction(modelName)
-    { cache = 0.0;}
+    G4InelasticInteraction(const G4String& modelName = "LEInelastic"); 
     
-    virtual ~G4InelasticInteraction()
-    { }
+    virtual ~G4InelasticInteraction();
     
- protected:
+protected:
     
     G4double Pmltpc( G4int np, G4int nm, G4int nz, G4int n,
@@ -100,10 +98,10 @@
                       G4ReactionProduct &targetParticle,
                       G4bool &incidentHasChanged );
-   private:
+private:
    
       G4double cache;
       G4ThreeVector what;
 
- };
+};
  
 #endif
Index: trunk/source/processes/hadronic/models/management/src/G4HadronicInteraction.cc
===================================================================
--- trunk/source/processes/hadronic/models/management/src/G4HadronicInteraction.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/management/src/G4HadronicInteraction.cc	(revision 1055)
@@ -24,27 +24,45 @@
 // ********************************************************************
 //
+// $Id: G4HadronicInteraction.cc,v 1.4 2009/01/24 11:56:27 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
- // Hadronic Interaction  base class
- // original by H.P. Wellisch
- // modified by J.L. Chuma, TRIUMF, 21-Mar-1997
- // Last modified: 04-Apr-1997
- // reimplemented 1.11.2003 JPW.
- 
+// Hadronic Interaction  base class
+// original by H.P. Wellisch
+// modified by J.L. Chuma, TRIUMF, 21-Mar-1997
+// Last modified: 04-Apr-1997
+// reimplemented 1.11.2003 JPW.
+// 23-Jan-2009 V.Ivanchenko move constructor and destructor to the body
+
 #include "G4HadronicInteraction.hh"
- 
- G4double
-  G4HadronicInteraction::GetMinEnergy(
+#include "G4HadronicInteractionRegistry.hh"
+#include "G4HadronicException.hh"
+
+G4HadronicInteraction::G4HadronicInteraction(const G4String& modelName) :
+  verboseLevel(0), theMinEnergy(0.0*GeV), theMaxEnergy(25.0*GeV), 
+  isBlocked(false), theModelName(modelName)
+{ 
+  G4HadronicInteractionRegistry::Instance()->RegisterMe(this);
+}
+    
+G4HadronicInteraction::~G4HadronicInteraction()
+{
+  G4HadronicInteractionRegistry::Instance()->RemoveMe(this);
+}
+ 
+G4double G4HadronicInteraction::GetMinEnergy(
    const G4Material *aMaterial, const G4Element *anElement ) const
-  {
-    size_t i;
-    if( IsBlocked(aMaterial) )return 0.*GeV;
-    if( IsBlocked(anElement) )return 0.*GeV;
-    for( i=0; i<theMinEnergyListElements.size(); ++i )
-    {
-      if( anElement == theMinEnergyListElements[i].second )return theMinEnergyListElements[i].first;
+{
+  size_t i;
+  if( IsBlocked(aMaterial) )return 0.*GeV;
+  if( IsBlocked(anElement) )return 0.*GeV;
+  for( i=0; i<theMinEnergyListElements.size(); ++i )
+    {
+      if( anElement == theMinEnergyListElements[i].second )
+	return theMinEnergyListElements[i].first;
     }
     for( i=0; i<theMinEnergyList.size(); ++i )
     {
-      if( aMaterial == theMinEnergyList[i].second )return theMinEnergyList[i].first;
+      if( aMaterial == theMinEnergyList[i].second )
+	return theMinEnergyList[i].first;
     }
     if(IsBlocked()) return 0.*GeV;
@@ -54,17 +72,15 @@
            << " not found in min energy List" << G4endl;
     return theMinEnergy;
-  }
- 
- void
-  G4HadronicInteraction::SetMinEnergy(
-   G4double anEnergy,
-   G4Element *anElement )
-  {
-    if( IsBlocked(anElement) )
-      G4cout << "*** Warning from HadronicInteraction::SetMinEnergy" << G4endl
+}
+ 
+void G4HadronicInteraction::SetMinEnergy(G4double anEnergy,
+					 G4Element *anElement )
+{
+  if( IsBlocked(anElement) )
+    G4cout << "*** Warning from HadronicInteraction::SetMinEnergy" << G4endl
            << "    The model is not active for the Element  "
            << anElement->GetName() << "." << G4endl;
     
-    for( size_t i=0; i<theMinEnergyListElements.size(); ++i )
+  for( size_t i=0; i<theMinEnergyListElements.size(); ++i )
     {
       if( anElement == theMinEnergyListElements[i].second )
@@ -74,63 +90,60 @@
       }
     }
-    theMinEnergyListElements.push_back(std::pair<G4double, G4Element *>(anEnergy, anElement));
-  }
- 
- void
-  G4HadronicInteraction::SetMinEnergy(
-   G4double anEnergy,
-   G4Material *aMaterial )
-  {
-    if( IsBlocked(aMaterial) )
-      G4cout << "*** Warning from HadronicInteraction::SetMinEnergy" << G4endl
+  theMinEnergyListElements.push_back(std::pair<G4double, G4Element *>(anEnergy, anElement));
+}
+ 
+void G4HadronicInteraction::SetMinEnergy(G4double anEnergy,
+					 G4Material *aMaterial )
+{
+  if( IsBlocked(aMaterial) )
+    G4cout << "*** Warning from HadronicInteraction::SetMinEnergy" << G4endl
            << "    The model is not active for the Material "
            << aMaterial->GetName() << "." << G4endl;
     
-    for( size_t i=0; i<theMinEnergyList.size(); ++i )
+  for( size_t i=0; i<theMinEnergyList.size(); ++i )
     {
       if( aMaterial == theMinEnergyList[i].second )
-      {
-        theMinEnergyList[i].first = anEnergy;
-        return;
-      }
-    }
-    theMinEnergyList.push_back(std::pair<G4double, G4Material *>(anEnergy, aMaterial));
-  }
- 
- G4double
-  G4HadronicInteraction::GetMaxEnergy(
-   const G4Material *aMaterial, const G4Element *anElement ) const
-  {
-    size_t i;
-    if( IsBlocked(aMaterial) )return 0.0*GeV;
-    if( IsBlocked(anElement) )return 0.0*GeV;
-    for( i=0; i<theMaxEnergyListElements.size(); ++i )
-    {
-      if( anElement == theMaxEnergyListElements[i].second )return theMaxEnergyListElements[i].first;
+	{
+	  theMinEnergyList[i].first = anEnergy;
+	  return;
+	}
+    }
+  theMinEnergyList.push_back(std::pair<G4double, G4Material *>(anEnergy, aMaterial));
+}
+ 
+G4double G4HadronicInteraction::GetMaxEnergy(const G4Material *aMaterial, 
+					     const G4Element *anElement ) const
+{
+  size_t i;
+  if( IsBlocked(aMaterial) )return 0.0*GeV;
+  if( IsBlocked(anElement) )return 0.0*GeV;
+  for( i=0; i<theMaxEnergyListElements.size(); ++i )
+    {
+      if( anElement == theMaxEnergyListElements[i].second )
+	return theMaxEnergyListElements[i].first;
     }
     for( i=0; i<theMaxEnergyList.size(); ++i )
     {
-      if( aMaterial == theMaxEnergyList[i].second )return theMaxEnergyList[i].first;
+      if( aMaterial == theMaxEnergyList[i].second )
+	return theMaxEnergyList[i].first;
     }
     if(IsBlocked()) return 0.*GeV;
     if( verboseLevel > 0 )
       G4cout << "*** Warning from HadronicInteraction::GetMaxEnergy" << G4endl
-           << "    material " << aMaterial->GetName()
-           << " not found in min energy List" << G4endl;
+	     << "    material " << aMaterial->GetName()
+	     << " not found in min energy List" << G4endl;
     
     return theMaxEnergy;
-  }
- 
- void
-  G4HadronicInteraction::SetMaxEnergy(
-   G4double anEnergy,
-   G4Element *anElement ) 
-  {
-    if( IsBlocked(anElement) )
-      G4cout << "*** Warning from HadronicInteraction::SetMaxEnergy" << G4endl
+}
+ 
+void G4HadronicInteraction::SetMaxEnergy(G4double anEnergy,
+					 G4Element *anElement ) 
+{
+  if( IsBlocked(anElement) )
+    G4cout << "*** Warning from HadronicInteraction::SetMaxEnergy" << G4endl
            << "Warning: The model is not active for the Element  "
            << anElement->GetName() << "." << G4endl;
     
-    for( size_t i=0; i<theMaxEnergyListElements.size(); ++i )
+  for( size_t i=0; i<theMaxEnergyListElements.size(); ++i )
     {
       if( anElement == theMaxEnergyListElements[i].second )
@@ -140,66 +153,73 @@
       }
     }
-    theMaxEnergyListElements.push_back(std::pair<G4double, G4Element *>(anEnergy, anElement));
-  }
-
- void
-  G4HadronicInteraction::SetMaxEnergy(
-   G4double anEnergy,
-   G4Material *aMaterial )
-  {
-    if( IsBlocked(aMaterial) ) 
-      G4cout << "*** Warning from HadronicInteraction::SetMaxEnergy" << G4endl
+  theMaxEnergyListElements.push_back(std::pair<G4double, G4Element *>(anEnergy, anElement));
+}
+
+void G4HadronicInteraction::SetMaxEnergy(G4double anEnergy,
+					 G4Material *aMaterial )
+{
+  if( IsBlocked(aMaterial) ) 
+    G4cout << "*** Warning from HadronicInteraction::SetMaxEnergy" << G4endl
            << "Warning: The model is not active for the Material "
            << aMaterial->GetName() << "." << G4endl;
     
-    for( size_t i=0; i<theMaxEnergyList.size(); ++i )
+  for( size_t i=0; i<theMaxEnergyList.size(); ++i )
     {
       if( aMaterial == theMaxEnergyList[i].second )
-      {
+	{
         theMaxEnergyList[i].first = anEnergy;
         return;
-      }
-    }
-    theMaxEnergyList.push_back(std::pair<G4double, G4Material *>(anEnergy, aMaterial));
-  }
-
- void 
-  G4HadronicInteraction::DeActivateFor( G4Material *aMaterial )
-  {
-    theBlockedList.push_back(aMaterial);
-  }
-
- void 
-  G4HadronicInteraction::DeActivateFor( G4Element *anElement )
-  {
-    theBlockedListElements.push_back(anElement);
-  }
-
- G4bool 
-  G4HadronicInteraction::IsBlocked( const G4Material *aMaterial ) const
-  {
-    for( size_t i=0; i<theBlockedList.size(); ++i )
+	}
+    }
+  theMaxEnergyList.push_back(std::pair<G4double, G4Material *>(anEnergy, aMaterial));
+}
+
+void G4HadronicInteraction::DeActivateFor( G4Material *aMaterial )
+{
+  theBlockedList.push_back(aMaterial);
+}
+
+void G4HadronicInteraction::DeActivateFor( G4Element *anElement )
+{
+  theBlockedListElements.push_back(anElement);
+}
+
+G4bool G4HadronicInteraction::IsBlocked( const G4Material *aMaterial ) const
+{
+  for( size_t i=0; i<theBlockedList.size(); ++i )
     {
       if( aMaterial == theBlockedList[i] )
-      {
-        return true;
-      }
-    }
-    return false;
-  }
- 
- G4bool 
-  G4HadronicInteraction::IsBlocked( const G4Element *anElement ) const
-  {
-    for( size_t i=0; i<theBlockedListElements.size(); ++i )
+	{
+	  return true;
+	}
+    }
+  return false;
+}
+ 
+G4bool G4HadronicInteraction::IsBlocked( const G4Element *anElement ) const
+{
+  for( size_t i=0; i<theBlockedListElements.size(); ++i )
     {
       if( anElement == theBlockedListElements[i] )
-      {
-        return true;
-      }
-    }
-    return false;
-  }
- 
- /* end of file */
- 
+	{
+	  return true;
+	}
+    }
+  return false;
+}
+
+G4HadronicInteraction::G4HadronicInteraction(const G4HadronicInteraction &right )
+{ 
+  *this = right; 
+}
+    
+const G4HadronicInteraction& 
+G4HadronicInteraction::operator=(const G4HadronicInteraction &right )
+{ 
+  G4String text = "unintended use of G4HadronicInteraction::operator=";
+  throw G4HadronicException(__FILE__, __LINE__, text); 
+  return right;
+}
+ 
+/* end of file */
+ 
Index: trunk/source/processes/hadronic/models/management/src/G4HadronicInteractionRegistry.cc
===================================================================
--- trunk/source/processes/hadronic/models/management/src/G4HadronicInteractionRegistry.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/management/src/G4HadronicInteractionRegistry.cc	(revision 1055)
@@ -24,11 +24,48 @@
 // ********************************************************************
 //
+// $Id: G4HadronicInteractionRegistry.cc,v 1.7 2009/02/25 16:30:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// 23-Jan-2009 V.Ivanchenko make the class to be a singleton
+
 #include "G4HadronicInteractionRegistry.hh"
 #include "G4HadronicInteraction.hh"
 
-G4HadronicInteractionRegistry & G4HadronicInteractionRegistry::theRegistry()
+G4HadronicInteractionRegistry* G4HadronicInteractionRegistry::theInstance = 0;
+
+G4HadronicInteractionRegistry* G4HadronicInteractionRegistry::Instance()
 {
-  static G4HadronicInteractionRegistry theRegistryInstance;
-  return theRegistryInstance;
+  if(0 == theInstance) {
+    static G4HadronicInteractionRegistry manager;
+    theInstance = &manager;
+  }
+  return theInstance;
+}
+
+G4HadronicInteractionRegistry::G4HadronicInteractionRegistry()
+{
+  nModels = 0;
+}
+
+G4HadronicInteractionRegistry::~G4HadronicInteractionRegistry()
+{
+  Clean();
+}
+
+void G4HadronicInteractionRegistry::Clean()
+{
+  //G4cout << "G4HadronicInteractionRegistry::Clean() start " << nModels << G4endl;
+  if(0 < nModels) {
+    for (G4int i=0; i<nModels; i++) {
+      if( allModels[i] ) {
+	//G4cout << "delete " << i << G4endl;
+        //G4cout << allModels[i]->GetModelName() << G4endl;
+	delete allModels[i];
+	allModels[i] = 0;
+      }
+    }
+  }
+  //G4cout << "G4HadronicInteractionRegistry::Clean() is done " << G4endl; 
+  nModels = 0;
 }
 
@@ -36,5 +73,13 @@
 RegisterMe(G4HadronicInteraction * aModel)
 {
-  theRegistry().AddModel(aModel);
+  if(nModels > 0) {
+    for (G4int i=0; i<nModels; i++) {
+      if( aModel == allModels[i] ) return;
+    }
+  }
+  //G4cout << "Register model <" << aModel->GetModelName() 
+  //<< ">  " << nModels << G4endl;
+  allModels.push_back(aModel);
+  nModels++;
 }
 
@@ -42,35 +87,13 @@
 RemoveMe(G4HadronicInteraction * aModel)
 {
-  theRegistry().allModels.erase(std::find(theRegistry().allModels.begin(),
-                                          theRegistry().allModels.end(), aModel));
-  theRegistry().nModels = theRegistry().allModels.size();
-}
-
-G4HadronicInteractionRegistry::~G4HadronicInteractionRegistry()
-{
-  /*
-  while(allModels.size()!=0)
-  {
-    delete allModels.front();
-  }
-  */
-}
-
-void G4HadronicInteractionRegistry::
-AddModel(G4HadronicInteraction * aModel)
-{
-  G4bool alreadyThere = false;
-  for(G4int i=0; i<nModels; i++)
-  {
-    if(allModels[i]==aModel)
-    {
-      alreadyThere = true;
-      break;
+  if(nModels > 0) {
+    for (G4int i=0; i<nModels; i++) {
+      if( aModel == allModels[i] ) {
+	//G4cout << "DeRegister model <" << aModel->GetModelName() 
+	//<< ">  " << i << G4endl;
+	allModels[i] = 0;
+	return;
+      }
     }
   }
-  if(!alreadyThere)
-  {
-    nModels++;
-    allModels.push_back(aModel);
-  }
 }
